<script lang="ts" setup>
import { defineProps } from 'vue';

interface Block {
  header: string;
  description?: string;
}

defineProps({
  header: {
    type: String,
    required: true,
  },
  description: {
    type: String,
    required: true,
  },
  primary: {
    type: Object as PropType<Block>,
    required: true,
  },
  secondary: {
    type: Object as PropType<Block>,
    required: true,
  },
  cta: {
    type: Object as PropType<Block>,
    required: false,
  },
  footnote: {
    type: String,
    required: false,
    default: '',
  },
});
</script>

<template>
  <SlpContainer>
    <SlpRow class="overview-blocks" :class="`overview-blocks--early-access`">
      <SlpRow class="overview-blocks-header">
        <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-24">
          {{ header }}
        </SlpTypography>
        <SlpTypography tag="p" variant="body1" class="slp-mb-48">
          {{ description }}
        </SlpTypography>
      </SlpRow>

      <SlpColumn :cols="6" size="lg">
        <div class="primary-block card" :class="`primary-block card--early-access`">
          <SlpTypography tag="h2" :variant="'heading5-bold'" class="slp-mb-24">
            {{ primary.header }}
          </SlpTypography>
          <SlpTypography v-if="primary?.description" variant="body1" tag="div">
            <div class="primary-block card-description" v-html="$md.render(primary.description)"></div>
          </SlpTypography>
        </div>
      </SlpColumn>

      <SlpColumn v-if="secondary" :cols="6" size="lg">
        <div class="secondary-blocks" :class="`secondary-blocks--early-access`">
          <div class="top-block card" :class="`top-block--early-access`">
            <SlpTypography tag="h2" variant="heading5-bold" class="slp-mb-24">
              {{ secondary.header }}
            </SlpTypography>
            <SlpTypography v-if="secondary.description" variant="heading5" tag="div">
              <div v-html="$md.render(secondary.description)"></div>
            </SlpTypography>
          </div>
          <div v-if="cta" class="bottom-block" :class="`bottom-block--early-access card`">
            <SlpTypography tag="h2" variant="heading5-bold" class="slp-mb-24">
              {{ cta.header }}
            </SlpTypography>
            <SlpTypography variant="heading5">
              <div class="slp-mb-24" v-html="$md.render(cta.description)"></div>
            </SlpTypography>
          </div>
        </div>
      </SlpColumn>

      <SlpRow v-if="footnote">
        <SlpTypography class="subheader" variant="quotes" tag="div">
          {{ footnote }}
        </SlpTypography>
      </SlpRow>
    </SlpRow>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.overview-blocks {
  @media (min-width: $breakpoint-lg) {
    margin-left: -$spacing-32;
    margin-bottom: 0;
  }
  :deep(.slp-col-lg-6) {
    width: 100%;
    @media (min-width: $breakpoint-lg) {
      padding-left: $spacing-32;
    }
  }

  &--early-access {
    margin-top: 160px;
    @media (min-width: $breakpoint-lg) {
      margin-left: 0;
    }
    @media (min-width: $breakpoint-lg) {
      :deep(.slp-col-lg-6) {
        padding-left: 0;
      }
    }
    .secondary-blocks {
      margin-left: $spacing-32;
      .top-block {
        padding: 40px;
      }
      .bottom-block {
        padding: 40px !important;
      }
    }
  }
  &-header {
    flex-direction: column;
  }

  .primary-block {
    margin-bottom: 40px;
    height: auto;
    @media (min-width: $breakpoint-lg) {
      height: 100%;
      margin-bottom: 0;
    }
  }
  .secondary-blocks {
    display: flex;
    flex-direction: column;
    &--early-access {
      height: 100%;
    }

    .top-block {
      margin-bottom: 40px;
      &--early-access {
        height: 50%;
      }
    }
  }
  :deep(a) {
    &:hover,
    &:focus,
    &:active {
      text-decoration: underline !important;
    }
  }
}
.subheader {
  font-size: 18px !important;
  margin-top: 48px;
}
.card {
  background: $color-primary-300;
  border: 1px solid $color-surface-200;
  border-radius: 8px;
  padding: $spacing-48 $spacing-24 $spacing-16 $spacing-24;
  &--early-access {
    .card-description {
      :deep(p) {
        line-height: 40px !important;
        padding-bottom: 12px;
        a {
          padding-right: 12px;
        }
        code {
          background: $color-surface-800;
          color: $color-accent-500;
        }
      }
    }
  }
}
</style>
